searchData={"content_type":"text/markdown","items":[{"doc":"","ref":"HareMq.html","title":"HareMq","type":"module"},{"doc":"","ref":"HareMq.html#start/2","title":"HareMq.start/2","type":"function"},{"doc":"Configuration module for HareMq.\n\nThis module provides functions for configuring HareMq components, such as queues and connections.","ref":"HareMq.Configuration.html","title":"HareMq.Configuration","type":"module"},{"doc":"Structure representing the configuration for a queue.","ref":"HareMq.Configuration.html#__struct__/0","title":"HareMq.Configuration.__struct__/0","type":"function"},{"doc":"- `:channel`: The AMQP channel.\n- `:queue_name`: The name of the queue.\n- `:delay_queue_name`: The name of the delay queue.\n- `:dead_queue_name`: The name of the dead letter queue.\n- `:exchange`: The AMQP exchange.\n- `:routing_key`: The routing key.\n- `:delay_in_ms`: The delay in milliseconds.\n- `:message_ttl`: The message time-to-live.\n- `:retry_limit`: The number of retry attempts.\n- `:durable`: Whether the queue is durable or not.","ref":"HareMq.Configuration.html#__struct__/0-fields","title":"Fields - HareMq.Configuration.__struct__/0","type":"function"},{"doc":"config = %Configuration{...}","ref":"HareMq.Configuration.html#__struct__/0-examples","title":"Examples - HareMq.Configuration.__struct__/0","type":"function"},{"doc":"Get the configuration for a queue.","ref":"HareMq.Configuration.html#get_queue_configuration/1","title":"HareMq.Configuration.get_queue_configuration/1","type":"function"},{"doc":"config = get_queue_configuration(\n      channel: channel,\n      name: name,\n      exchange: exchange,\n      routing_key: routing_key\n    )","ref":"HareMq.Configuration.html#get_queue_configuration/1-examples","title":"Examples - HareMq.Configuration.get_queue_configuration/1","type":"function"},{"doc":"GenServer module for managing AMQP connection.\n\nThis module handles the lifecycle of the AMQP connection and provides functions for getting, closing, and monitoring the connection.","ref":"HareMq.Connection.html","title":"HareMq.Connection","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"HareMq.Connection.html#child_spec/1","title":"HareMq.Connection.child_spec/1","type":"function"},{"doc":"Close the current connection.\n\nReturns:\n  - `{:ok, connection}`: If the connection is successfully closed.\n  - `{:error, :not_connected}`: If the connection is not established.","ref":"HareMq.Connection.html#close_connection/0","title":"HareMq.Connection.close_connection/0","type":"function"},{"doc":"case HareMq.Connection.close_connection() do\n      {:ok, conn} -> IO.inspect(conn)\n      {:error, :not_connected} -> IO.puts(\"Not connected!\")\n    end","ref":"HareMq.Connection.html#close_connection/0-examples","title":"Examples - HareMq.Connection.close_connection/0","type":"function"},{"doc":"Get the current connection.\n\nReturns:\n  - `{:ok, connection}`: If the connection is established.\n  - `{:error, :not_connected}`: If the connection is not established.","ref":"HareMq.Connection.html#get_connection/0","title":"HareMq.Connection.get_connection/0","type":"function"},{"doc":"case HareMq.Connection.get_connection() do\n      {:ok, conn} -> IO.inspect(conn)\n      {:error, :not_connected} -> IO.puts(\"Not connected!\")\n    end","ref":"HareMq.Connection.html#get_connection/0-examples","title":"Examples - HareMq.Connection.get_connection/0","type":"function"},{"doc":"","ref":"HareMq.Connection.html#init/1","title":"HareMq.Connection.init/1","type":"function"},{"doc":"","ref":"HareMq.Connection.html#start_link/1","title":"HareMq.Connection.start_link/1","type":"function"},{"doc":"GenServer module implementing a RabbitMQ consumer.\n\nThis module provides a behavior for RabbitMQ message consumption, including connecting to RabbitMQ, declaring queues, and handling incoming messages.","ref":"HareMq.Consumer.html","title":"HareMq.Consumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"HareMq.Consumer.html#child_spec/1","title":"HareMq.Consumer.child_spec/1","type":"function"},{"doc":"","ref":"HareMq.Consumer.html#init/1","title":"HareMq.Consumer.init/1","type":"function"},{"doc":"","ref":"HareMq.Consumer.Behaviour.html","title":"HareMq.Consumer.Behaviour","type":"behaviour"},{"doc":"","ref":"HareMq.Consumer.Behaviour.html#c:consume/1","title":"HareMq.Consumer.Behaviour.consume/1","type":"callback"},{"doc":"","ref":"HareMq.Ddc.html","title":"HareMq.Ddc","type":"module"},{"doc":"","ref":"HareMq.Ddc.html#child_spec/1","title":"HareMq.Ddc.child_spec/1","type":"function"},{"doc":"Callback for processing incoming messages.\n\nImplement this callback in your consumer module to define how to handle incoming messages.","ref":"HareMq.Ddc.html#consume/1","title":"HareMq.Ddc.consume/1","type":"function"},{"doc":"defmodule MyConsumer do\n      use HareMq.Consumer, queue_name: \"my_queue\", routing_key: \"my_routing_key\"\n\n      def consume(message) do\n        IO.puts(\"Received message: #{inspect(message)}\")\n        :ok\n      end\n    end","ref":"HareMq.Ddc.html#consume/1-examples","title":"Examples - HareMq.Ddc.consume/1","type":"function"},{"doc":"","ref":"HareMq.Ddc.html#declare_queues/2","title":"HareMq.Ddc.declare_queues/2","type":"function"},{"doc":"","ref":"HareMq.Ddc.html#get_channel/0","title":"HareMq.Ddc.get_channel/0","type":"function"},{"doc":"","ref":"HareMq.Ddc.html#handle_call/3","title":"HareMq.Ddc.handle_call/3","type":"function"},{"doc":"","ref":"HareMq.Ddc.html#handle_info/2","title":"HareMq.Ddc.handle_info/2","type":"function"},{"doc":"","ref":"HareMq.Ddc.html#init/1","title":"HareMq.Ddc.init/1","type":"function"},{"doc":"","ref":"HareMq.Ddc.html#republish_dead_messages/1","title":"HareMq.Ddc.republish_dead_messages/1","type":"function"},{"doc":"","ref":"HareMq.Ddc.html#start_link/1","title":"HareMq.Ddc.start_link/1","type":"function"},{"doc":"","ref":"HareMq.Ddc.html#terminate/2","title":"HareMq.Ddc.terminate/2","type":"function"},{"doc":"","ref":"HareMq.Ddp.html","title":"HareMq.Ddp","type":"module"},{"doc":"","ref":"HareMq.Ddp.html#child_spec/1","title":"HareMq.Ddp.child_spec/1","type":"function"},{"doc":"","ref":"HareMq.Ddp.html#get_channel/0","title":"HareMq.Ddp.get_channel/0","type":"function"},{"doc":"","ref":"HareMq.Ddp.html#handle_call/3","title":"HareMq.Ddp.handle_call/3","type":"function"},{"doc":"","ref":"HareMq.Ddp.html#handle_info/2","title":"HareMq.Ddp.handle_info/2","type":"function"},{"doc":"","ref":"HareMq.Ddp.html#init/1","title":"HareMq.Ddp.init/1","type":"function"},{"doc":"","ref":"HareMq.Ddp.html#publish/0","title":"HareMq.Ddp.publish/0","type":"function"},{"doc":"Func for publishing messages.","ref":"HareMq.Ddp.html#publish_message/1","title":"HareMq.Ddp.publish_message/1","type":"function"},{"doc":"defmodule MyPublisher do\n      use HareMq.Publisher, exchange: \"my_exchange\", routing_key: \"my_routing_key\"\n\n      def publish() do\n        message = %{key: \"value\"}\n        HareMq.Publisher.publish_message(message)\n      end\n    end","ref":"HareMq.Ddp.html#publish_message/1-examples","title":"Examples - HareMq.Ddp.publish_message/1","type":"function"},{"doc":"","ref":"HareMq.Ddp.html#start_link/1","title":"HareMq.Ddp.start_link/1","type":"function"},{"doc":"Module providing functions for managing RabbitMQ exchanges.\n\nThis module includes functions for declaring and binding exchanges.","ref":"HareMq.Exchange.html","title":"HareMq.Exchange","type":"module"},{"doc":"Bind a RabbitMQ exchange to a destination.","ref":"HareMq.Exchange.html#bind/1","title":"HareMq.Exchange.bind/1","type":"function"},{"doc":"- `:channel`: The AMQP channel.\n- `:destination`: The name of the destination exchange or queue.\n- `:source`: The name of the source exchange.\n- `:routing_key`: The routing key.","ref":"HareMq.Exchange.html#bind/1-parameters","title":"Parameters - HareMq.Exchange.bind/1","type":"function"},{"doc":"HareMq.Exchange.bind(channel: channel, destination: \"destination_exchange\", source: \"my_exchange\", routing_key: \"my_routing_key\")","ref":"HareMq.Exchange.html#bind/1-examples","title":"Examples - HareMq.Exchange.bind/1","type":"function"},{"doc":"Declare a RabbitMQ exchange.","ref":"HareMq.Exchange.html#declare/1","title":"HareMq.Exchange.declare/1","type":"function"},{"doc":"- `:channel`: The AMQP channel.\n- `:name`: The name of the exchange.\n- `:type`: The type of the exchange.","ref":"HareMq.Exchange.html#declare/1-parameters","title":"Parameters - HareMq.Exchange.declare/1","type":"function"},{"doc":"HareMq.Exchange.declare(channel: channel, name: \"my_exchange\", type: :direct)\n    HareMq.Exchange.declare(channel: channel, name: \"my_exchange\")","ref":"HareMq.Exchange.html#declare/1-examples","title":"Examples - HareMq.Exchange.declare/1","type":"function"},{"doc":"GenServer module implementing a RabbitMQ message publisher.\n\nThis module provides a behavior for publishing messages to RabbitMQ, including connecting to RabbitMQ, declaring exchanges, and sending messages.","ref":"HareMq.Publisher.html","title":"HareMq.Publisher","type":"module"},{"doc":"","ref":"HareMq.Publisher.Behaviour.html","title":"HareMq.Publisher.Behaviour","type":"behaviour"},{"doc":"","ref":"HareMq.Publisher.Behaviour.html#c:publish_message/1","title":"HareMq.Publisher.Behaviour.publish_message/1","type":"callback"},{"doc":"Module providing functions for managing RabbitMQ queues.\n\nThis module includes functions for declaring queues and binding them to exchanges.","ref":"HareMq.Queue.html","title":"HareMq.Queue","type":"module"},{"doc":"Bind a queue to an exchange with the specified routing key.","ref":"HareMq.Queue.html#bind/1","title":"HareMq.Queue.bind/1","type":"function"},{"doc":"- `config`: A `%Configuration{}` struct containing queue configuration.","ref":"HareMq.Queue.html#bind/1-parameters","title":"Parameters - HareMq.Queue.bind/1","type":"function"},{"doc":"HareMq.Queue.bind(%Configuration{channel: channel, queue_name: \"my_queue\", exchange: \"my_exchange\", routing_key: \"my_routing_key\"})","ref":"HareMq.Queue.html#bind/1-examples","title":"Examples - HareMq.Queue.bind/1","type":"function"},{"doc":"Declare a durable RabbitMQ dead letter queue with specified options.","ref":"HareMq.Queue.html#declare_dead_queue/1","title":"HareMq.Queue.declare_dead_queue/1","type":"function"},{"doc":"- `config`: A `%Configuration{}` struct containing queue configuration.","ref":"HareMq.Queue.html#declare_dead_queue/1-parameters","title":"Parameters - HareMq.Queue.declare_dead_queue/1","type":"function"},{"doc":"HareMq.Queue.declare_dead_queue(%Configuration{channel: channel, dead_queue_name: \"my_queue.dead\", message_ttl: 3600000})","ref":"HareMq.Queue.html#declare_dead_queue/1-examples","title":"Examples - HareMq.Queue.declare_dead_queue/1","type":"function"},{"doc":"Declare a durable RabbitMQ delay queue with specified options.","ref":"HareMq.Queue.html#declare_delay_queue/1","title":"HareMq.Queue.declare_delay_queue/1","type":"function"},{"doc":"- `config`: A `%Configuration{}` struct containing queue configuration.","ref":"HareMq.Queue.html#declare_delay_queue/1-parameters","title":"Parameters - HareMq.Queue.declare_delay_queue/1","type":"function"},{"doc":"HareMq.Queue.declare_delay_queue(%Configuration{channel: channel, delay_queue_name: \"my_queue.delay\", exchange: \"my_exchange\", routing_key: \"my_routing_key\", delay_in_ms: 5000})","ref":"HareMq.Queue.html#declare_delay_queue/1-examples","title":"Examples - HareMq.Queue.declare_delay_queue/1","type":"function"},{"doc":"Declare a durable RabbitMQ queue.","ref":"HareMq.Queue.html#declare_queue/1","title":"HareMq.Queue.declare_queue/1","type":"function"},{"doc":"- `config`: A `%Configuration{}` struct containing queue configuration.","ref":"HareMq.Queue.html#declare_queue/1-parameters","title":"Parameters - HareMq.Queue.declare_queue/1","type":"function"},{"doc":"HareMq.Queue.declare_queue(%Configuration{channel: channel, queue_name: \"my_queue\", durable: true})","ref":"HareMq.Queue.html#declare_queue/1-examples","title":"Examples - HareMq.Queue.declare_queue/1","type":"function"},{"doc":"Module providing functions for republishing dead messages with retry handling.\n\nThis module includes functions for republishing messages from a dead letter queue to the original exchange.","ref":"HareMq.RetryPublisher.html","title":"HareMq.RetryPublisher","type":"module"},{"doc":"Republish a message to either a delay or dead letter queue based on the retry count.","ref":"HareMq.RetryPublisher.html#republish/3","title":"HareMq.RetryPublisher.republish/3","type":"function"},{"doc":"- `payload`: The message payload.\n- `configuration`: A `%Configuration{}` struct containing queue configuration.\n- `metadata`: Message metadata.","ref":"HareMq.RetryPublisher.html#republish/3-parameters","title":"Parameters - HareMq.RetryPublisher.republish/3","type":"function"},{"doc":"HareMq.RetryPublisher.republish(payload, configuration, metadata)","ref":"HareMq.RetryPublisher.html#republish/3-examples","title":"Examples - HareMq.RetryPublisher.republish/3","type":"function"},{"doc":"Republish a specified number of dead messages from the dead letter queue.","ref":"HareMq.RetryPublisher.html#republish_dead_messages/2","title":"HareMq.RetryPublisher.republish_dead_messages/2","type":"function"},{"doc":"- `configuration`: A `%Configuration{}` struct containing queue configuration.\n- `count`: The number of dead messages to republish.","ref":"HareMq.RetryPublisher.html#republish_dead_messages/2-parameters","title":"Parameters - HareMq.RetryPublisher.republish_dead_messages/2","type":"function"},{"doc":"HareMq.RetryPublisher.republish_dead_messages(configuration, 5)","ref":"HareMq.RetryPublisher.html#republish_dead_messages/2-examples","title":"Examples - HareMq.RetryPublisher.republish_dead_messages/2","type":"function"},{"doc":"Determine the retry count from message headers.","ref":"HareMq.RetryPublisher.html#retry_count/1","title":"HareMq.RetryPublisher.retry_count/1","type":"function"},{"doc":"- `headers`: Message headers.","ref":"HareMq.RetryPublisher.html#retry_count/1-parameters","title":"Parameters - HareMq.RetryPublisher.retry_count/1","type":"function"},{"doc":"retry_count = HareMq.RetryPublisher.retry_count(headers)","ref":"HareMq.RetryPublisher.html#retry_count/1-examples","title":"Examples - HareMq.RetryPublisher.retry_count/1","type":"function"}]}